var NAVTREE =
[
  [ "P6R", "index.html", [
    [ "The SKC Secure KMIP Client Toolkit", "index.html", [
      [ "Introduction", "index.html#skc-intro", null ],
      [ "Getting Help", "index.html#skc-help", null ],
      [ "Getting Started", "index.html#main_start", null ],
      [ "Reference Guides", "index.html#skc-refguide", null ],
      [ "Examples", "index.html#skc-examples-introduction", null ]
    ] ],
    [ "SKC Directory Structure", "skc-dir.html", [
      [ "Overview", "skc-dir.html#skc-dir-overview", null ]
    ] ],
    [ "Building The Examples", "skc-build-examples.html", [
      [ "Overview", "skc-build-examples.html#skc-build-examples-overview", [
        [ "Building Examples On Windows", "skc-build-examples.html#skc-build-examples-windows", null ],
        [ "Building on Non-Windows", "skc-build-examples.html#skc-build-examples-non-windows", null ]
      ] ]
    ] ],
    [ "Building Your Application With SKC", "skc-building.html", [
      [ "Overview", "skc-building.html#skc-building-overview", [
        [ "Steps For Building With SKC", "skc-building.html#skc-building-steps", null ]
      ] ]
    ] ],
    [ "Loading Components", "skc-load.html", [
      [ "Overview", "skc-load.html#skc-load-overview", null ]
    ] ],
    [ "Deploying SKC", "skc-deploy.html", [
      [ "Overview", "skc-deploy.html#skc-deploy-overview", [
        [ "Language Files", "skc-deploy.html#skc-deploy-lang", null ]
      ] ]
    ] ],
    [ "SKC Redistributibles", "skc-redist.html", null ],
    [ "SKC Toolkit Examples", "skc-examples.html", [
      [ "Introduction", "skc-examples.html#skc-examples-into", null ],
      [ ".cpp Loading SKC Components", "skc-examples.html#ex-loader", null ]
    ] ],
    [ "SKC References", "skc-references.html", null ],
    [ "cfilestream.h", "common_cfilestream_h.html", null ],
    [ "cfilestream.cpp", "common_cfilestream_cpp.html", null ],
    [ "cconsolestream.h", "common_cconsolestream_h.html", null ],
    [ "cconsolestream.cpp", "common_cconsolestream_cpp.html", null ],
    [ "Release Notes", "skc-releasenotes.html", null ],
    [ "KMIP Reference Guide", "p6kmip.html", [
      [ "Introduction", "p6kmip.html#p6kmip_intro", [
        [ "Includes", "p6kmip.html#p6kmip_includes", null ],
        [ "Interfaces", "p6kmip.html#p6kmip_interfaces", null ],
        [ "Ease of Use", "p6kmip.html#p6kmip_easeofuse", null ],
        [ "Server to Client Configuration Parameters", "p6kmip.html#p6kmip_config", null ],
        [ "Enumerators", "p6kmip.html#p6kmip_enumerators", null ],
        [ "Required KMIP Attributes", "p6kmip.html#p6kmip_required", null ],
        [ "Support for Notify and Put Operations", "p6kmip.html#p6kmip_server", null ],
        [ "Conformance", "p6kmip.html#p6kmip_conformance", null ],
        [ "Support for the Suite B Profile", "p6kmip.html#p6kmip_suiteb", null ]
      ] ]
    ] ],
    [ "KMIP Examples", "kmip_examples.html", [
      [ "KMIP Examples", "kmip_examples.html#kmip_ex_into", null ]
    ] ],
    [ "KMIP Example 1 - Basic Code Structure", "kmip_example1.html", null ],
    [ "ex-kmip-1.cpp", "kmip_example1_ex_kmip_1_cpp.html", null ],
    [ "KMIP Example 2 - Asynchronous KMIP operation", "kmip_example2.html", null ],
    [ "ex-kmip-2.cpp", "kmip_example2_ex_kmip_2_cpp.html", null ],
    [ "KMIP Example 3 - Key Wrapping", "kmip_example3.html", null ],
    [ "ex-kmip-3.cpp", "kmip_example3_ex_kmip_3_cpp.html", null ],
    [ "KMIP Example 4 - Register a symmetric key", "kmip_example4.html", null ],
    [ "ex-kmip-4.cpp", "kmip_example4_ex_kmip_4_cpp.html", null ],
    [ "KMIP Example 5 - Clean all managed objects off of KMIP server", "kmip_example5.html", null ],
    [ "ex-kmip-5.cpp", "kmip_example5_ex_kmip_5_cpp.html", null ],
    [ "KMIP Example 6 - Notify and Put Support", "kmip_example6.html", null ],
    [ "ex-kmip-6.cpp", "kmip_example6_ex_kmip_6_cpp.html", null ],
    [ "KMIP Example 7 - Create and register asymmetric keys", "kmip_example7.html", null ],
    [ "ex-kmip-7.cpp", "kmip_example7_ex_kmip_7_cpp.html", null ],
    [ "KMIP Example 8 - KMIP server creates asymmetric keys", "kmip_example8.html", null ],
    [ "ex-kmip-8.cpp", "kmip_example8_ex_kmip_8_cpp.html", null ],
    [ "KMIP Example 9 - KMIP server creates certificate for key pair", "kmip_example9.html", null ],
    [ "ex-kmip-9.cpp", "kmip_example9_ex_kmip_9_cpp.html", null ],
    [ "KMIP Example 10 - Adding multiple attributes to a managed object", "kmip_example10.html", null ],
    [ "ex-kmip-10.cpp", "kmip_example10_ex_kmip_10_cpp.html", null ],
    [ "KMIP Example 11 - Attributes and Enumerators", "kmip_example11.html", null ],
    [ "ex-kmip-11.cpp", "kmip_example11_ex_kmip_11_cpp.html", null ],
    [ "KMIP Example 12 - Query Server and Enumerators", "kmip_example12.html", null ],
    [ "ex-kmip-12.cpp", "kmip_example12_ex_kmip_12_cpp.html", null ],
    [ "KMIP Example 13 - Low Level SDK APIs", "kmip_example13.html", null ],
    [ "ex-kmip-13.cpp", "kmip_example13_ex_kmip_13_cpp.html", null ],
    [ "KMIP Example 14 - Key Management with Low Level SDK APIs", "kmip_example14.html", null ],
    [ "ex-kmip-14.cpp", "kmip_example14_ex_kmip_14_cpp.html", null ],
    [ "KMIP Example 15 - A C Language version of example 1", "kmip_example15.html", null ],
    [ "ex-kmip-15.c", "kmip_example15_ex_kmip_15_c.html", null ],
    [ "KMIP Example 16 - Generate a KMIP keystore", "kmip_example16.html", null ],
    [ "ex-kmip-16.c", "kmip_example16_ex_kmip_16_c.html", null ],
    [ "KMIP Example 17 - Create a key if not found on KMIP server", "kmip_example17.html", null ],
    [ "ex-kmip-17.c", "kmip_example17_ex_kmip_17_c.html", null ],
    [ "KMIP Example 18 - Rekey an existing key with a Name attribute", "kmip_example18.html", null ],
    [ "ex-kmip-18.c", "kmip_example18_ex_kmip_18_c.html", null ],
    [ "KMIP Example 19 - Locate and Get a Symmetric Key", "kmip_example19.html", null ],
    [ "ex-kmip-19.c", "kmip_example19_ex_kmip_19_c.html", null ],
    [ "KMIP Example 20 - Multiple Create Key Operations in a single KMIP Request", "kmip_example20.html", null ],
    [ "ex-kmip-20.c", "kmip_example20_ex_kmip_20_c.html", null ],
    [ "KMIP Example 21 - ReKey Operation Creating a Chain of Replaced Keys", "kmip_example21.html", null ],
    [ "ex-kmip-21.cpp", "kmip_example21_ex_kmip_21_cpp.html", null ],
    [ "HPE Atalla NSP PKCS 11 Reference Guide", "p6pkcs11.html", [
      [ "Introduction", "p6pkcs11.html#p6pkcs11_intro", null ],
      [ "Includes", "p6pkcs11.html#p6pkcs11_includes", null ],
      [ "Installation, Deployment, and Use", "p6pkcs11.html#p6pkcs11_deployment", null ],
      [ "A Secure Implementation", "p6pkcs11.html#p6pkcs11_secure", null ],
      [ "Basic Configuration Parameters", "p6pkcs11.html#p6pkcs11_config", [
        [ "The [p6pkcs11-gen] Config Section*", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen", [
          [ "\"baseKeyPath\" Config Variable (string Value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_baseKeyPath", null ],
          [ "\"customerKeyPath\" Config Variable (string Value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_customerKeyPath", null ],
          [ "\"keystore\" Config Variable (string value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_keystore", null ],
          [ "\"logdir\" Config Variable (string value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_logdir", null ],
          [ "\"pkcs11LibFlags\" Config Variable (positive numeric value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_pkcs11libflags", null ]
        ] ],
        [ "The [p6pkcs11-slots-gen] Config Section", "p6pkcs11.html#p6pkcs11_config_section_p6pkcs11_slots_gen", [
          [ "\"slotCount\" Config Variable (positive decimal integer)", "p6pkcs11.html#p6pkcs11_config_section_p6pkcs11_slots_gen_slotcount", null ]
        ] ],
        [ "The [p6pkcs11-tokens] Config Section", "p6pkcs11.html#p6pkcs11_config_section_p6pkcs11_tokens", [
          [ "<tokenname> Config Variable (string GUID)", "p6pkcs11.html#p6pkcs11_config_section_p6pkcs11_slots_tokenname", null ]
        ] ]
      ] ],
      [ "Low-Level and Debug Logging Configuration", "p6pkcs11.html#p6pkcs11_logging", [
        [ "Low-Level Logging", "p6pkcs11.html#p6pkcs11_logging_lowlevel", null ],
        [ "Debug Logging", "p6pkcs11.html#p6pkcs11_logging_debuglog", null ],
        [ "Controlling What Is Logged In The Debug Log", "p6pkcs11.html#p6pkcs11_logging_output", null ]
      ] ],
      [ "P6R's Command Line Tool", "p6pkcs11.html#p6pkcs11_tool", null ],
      [ "Hewlett Packard Enterprise (HPE) Atalla HSM Network Security Processor (NSP) Integration", "p6pkcs11.html#p6pkcs11_hpensp", null ],
      [ "KMIP Token", "p6pkcs11.html#p6pkcs11_kmip", null ],
      [ "Software Token", "p6pkcs11.html#p6pkcs11_soft", null ],
      [ "Other Tokens", "p6pkcs11.html#p6pkcs11_thirdparty", null ],
      [ "Unsupported, Limitations and Defaults", "p6pkcs11.html#p6pkcs11_limits", null ],
      [ "Supported Mechanisms", "p6pkcs11.html#p6pkcs11_mech", null ],
      [ "Vendor Extensions", "p6pkcs11.html#p6pkcs11_extend", null ],
      [ "Java Security Provider", "p6pkcs11.html#p6pkcs11_java", null ],
      [ "Utimaco HSM Integration", "p6pkcs11.html#p6pkcs11_utimaco", null ],
      [ "Thales HSM Integration", "p6pkcs11.html#p6pkcs11_thales", null ],
      [ "Futurex HSM Integration", "p6pkcs11.html#p6pkcs11_futurex", null ],
      [ "DocuSign ARX PrivateServer HSM Integration", "p6pkcs11.html#p6pkcs11_docusign", null ]
    ] ],
    [ "PKCS 11 Examples", "pkcs11_examples.html", [
      [ "PKCS 11 Examples", "pkcs11_examples.html#p6pkcs11_ex_intro", null ]
    ] ],
    [ "PKCS 11 Example 1: Initialize a token", "pkcs11_example1.html", null ],
    [ "ex-pkcs11-1.c", "pkcs11_example1_ex_pkcs11_1_c.html", null ],
    [ "PKCS 11 Example 2: Store a key onto a token", "pkcs11_example2.html", null ],
    [ "ex-pkcs11-2.c", "pkcs11_example2_ex_pkcs11_2_c.html", null ],
    [ "PKCS 11 Example 3: Search for a key on a token", "pkcs11_example3.html", null ],
    [ "ex-pkcs11-3.c", "pkcs11_example3_ex_pkcs11_3_c.html", null ],
    [ "PKCS 11 Example 4: Generate a key on a token", "pkcs11_example4.html", null ],
    [ "ex-pkcs11-4.c", "pkcs11_example4_ex_pkcs11_4_c.html", null ],
    [ "PKCS 11 Example 5: Perform Encryption / Decryption", "pkcs11_example5.html", null ],
    [ "ex-pkcs11-5.c", "pkcs11_example5_ex_pkcs11_5_c.html", null ],
    [ "PKCS 11 Example 6: Utimaco HSM Integration, Initialize a Token", "pkcs11_example6.html", null ],
    [ "ex-pkcs11-6.c", "pkcs11_example6_ex_pkcs11_6_c.html", null ],
    [ "PKCS 11 Example 7: Utimaco HSM Integration, Perform Encryption / Decryption", "pkcs11_example7.html", null ],
    [ "ex-pkcs11-7.c", "pkcs11_example7_ex_pkcs11_7_c.html", null ],
    [ "PKCS 11 Example 8: HSM Integration, list all slots on HSM token", "pkcs11_example8.html", null ],
    [ "ex-pkcs11-8.c", "pkcs11_example8_ex_pkcs11_8_c.html", null ],
    [ "PKCS 11 Example 9: Thales nShield Connect HSM Integration", "pkcs11_example9.html", null ],
    [ "ex-pkcs11-9.c", "pkcs11_example9_ex_pkcs11_9_c.html", null ],
    [ "PKCS 11 Example 10: FutureX HSM Integration", "pkcs11_example10.html", null ],
    [ "ex-pkcs11-10.c", "pkcs11_example10_ex_pkcs11_10_c.html", null ],
    [ "PKCS 11 Example 11: Java Security Provider -- Public/Private keys", "pkcs11_example11.html", null ],
    [ "KeyGenExample.java", "pkcs11_example11_ex_pkcs11_11_java.html", null ],
    [ "PKCS 11 Example 12: Java Security Provider -- Symmetric Keys", "pkcs11_example12.html", null ],
    [ "SymmetricKeyExample.java", "pkcs11_example12_ex_pkcs11_12_java.html", null ],
    [ "PKCS 11 Example 13: Java Security Provider -- Streaming Encryption", "pkcs11_example13.html", null ],
    [ "StreamingKeyExample.java", "pkcs11_example13_ex_pkcs11_13_java.html", null ],
    [ "PKCS 11 Example 14: Wrap a Key", "pkcs11_example14.html", null ],
    [ "ex-pkcs11-14.c", "pkcs11_example14_ex_pkcs11_14_c.html", null ],
    [ "p6Loader Examples", "p6loader-examples.html", [
      [ "Examples", "p6loader-examples.html#loader-examples", null ]
    ] ],
    [ "Basic example of loading a component library", "loader-ex-loader.html", null ],
    [ "p6api.cpp", "loader-p6api.html", null ],
    [ "JSN Reference", "p6json.html", [
      [ "Introduction", "p6json.html#p6rjson_intro", [
        [ "JSON Parser, XPATH, and XSLT", "p6json.html#p6rjson_sax", null ],
        [ "Includes", "p6json.html#p6rjson_includes", null ],
        [ "Interfaces", "p6json.html#p6rjson_interfaces", null ],
        [ "The Lifetime of P6JSONSTRING pointers", "p6json.html#p6rjson_lifetime", null ],
        [ "A Default Implementation of p6IJSONErrorHandler", "p6json.html#p6rjson_default", null ]
      ] ]
    ] ],
    [ "JSON Parser Examples", "json_examples.html", [
      [ "JSON Parser Examples", "json_examples.html#json_ex_into", null ]
    ] ],
    [ "JSON Example 1 - Verifying JSON Data", "json_example1.html", null ],
    [ "ex-json-1.cpp", "json_example1_ex_json_1_cpp.html", null ],
    [ "ccontenthandler.h", "json_example1_ccontenthandler_h.html", null ],
    [ "ccontenthandler.cpp", "json_example1_ccontenthandler_cpp.html", null ],
    [ "JSON Example 2 - How to detect errors", "json_example2.html", null ],
    [ "ex-json-2.cpp", "json_example2_ex_json_2_cpp.html", null ],
    [ "ccontenthandler.h", "json_example2_ccontenthandler_h.html", null ],
    [ "ccontenthandler.cpp", "json_example2_ccontenthandler_cpp.html", null ],
    [ "cerrorhandler.h", "json_example2_cerrorhandler_h.html", null ],
    [ "cerrorhandler.cpp", "json_example2_cerrorhandler_cpp.html", null ],
    [ "JSON Example 3 - The Bare Minimum", "json_example3.html", null ],
    [ "ex-json3.cpp", "json_example3_ex_json3_cpp.html", null ],
    [ "ccontenthandler.cpp", "json_example3_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "json_example3_ccontenthandler_h.html", null ],
    [ "SAX2 Reference", "p6sax2.html", [
      [ "Introduction", "p6sax2.html#p6rsax2_intro", [
        [ "References", "p6sax2.html#p6rsax2_refs", null ],
        [ "Includes", "p6sax2.html#p6rsax2_includes", null ],
        [ "Interfaces", "p6sax2.html#p6rsax2_interfaces", null ],
        [ "Differences between the Java SAX2 Interface and P6R's C++ Interface", "p6sax2.html#p6rsax2_difs", null ],
        [ "The Lifetime of P6SAX2STRING pointers", "p6sax2.html#p6rsax2_lifetime", null ],
        [ "Example of using XML parser", "p6sax2.html#p6rsax2_examples", null ],
        [ "A Default Implementation of p6ISAX2ErrorHandler", "p6sax2.html#p6rsax2_default", null ]
      ] ]
    ] ],
    [ "SAX2 Examples", "sax2_examples.html", [
      [ "SAX2 Examples", "sax2_examples.html#sax2_ex_into", null ]
    ] ],
    [ "SAX2 Example 1 - Set features and content handlers", "sax2_example1.html", null ],
    [ "ex-sax2-1.cpp", "sax2_example1_ex_sax2_1_cpp.html", null ],
    [ "ccontenthandler.cpp", "sax2_example1_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "sax2_example1_ccontenthandler_h.html", null ],
    [ "cerrorhandler.cpp", "sax2_example1_cerrorhandler_cpp.html", null ],
    [ "cerrorhandler.h", "sax2_example1_cerrorhandler_h.html", null ],
    [ "SAX2 Example 2 - Streaming Interface", "sax2_example2.html", null ],
    [ "ex-sax2-2.cpp", "sax2_example2_ex_sax2_2_cpp.html", null ],
    [ "ccontenthandler.cpp", "sax2_example2_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "sax2_example2_ccontenthandler_h.html", null ],
    [ "XPath 2.0 and DOM Tree Reference", "p6xpath.html", [
      [ "Introduction", "p6xpath.html#p6rxpath_intro", [
        [ "References", "p6xpath.html#p6rxpath_refs", null ],
        [ "Includes", "p6xpath.html#p6rxpath_includes", null ],
        [ "Interfaces", "p6xpath.html#p6rxpath_interfaces", null ],
        [ "JSON and JsonML Limitiations", "p6xpath.html#p6xpath_json", null ],
        [ "Collations", "p6xpath.html#p6rxpath_collate", null ],
        [ "Extensions to Existing XPath Functions", "p6xpath.html#p6rxpath_ext", null ],
        [ "P6R's Functions Not Yet Implemented", "p6xpath.html#p6rxpath_not", null ],
        [ "P6R's Extension Functions", "p6xpath.html#p6rxpath_extfunc", null ]
      ] ]
    ] ],
    [ "DOM & XPath 2.0 Examples", "dom_examples.html", [
      [ "DOM & XPath 2.0 Examples", "dom_examples.html#dom_ex_into", null ]
    ] ],
    [ "DOM/Xpath Example 1 - DOM & XPath 2.0", "dom_example1.html", null ],
    [ "ex-dom-1.cpp", "dom_example1_ex_dom_1_cpp.html", null ],
    [ "DOM/Xpath Example 2 - Manual Generation of XML, JSON and JsonML", "dom_example2.html", null ],
    [ "ex-dom-2.cpp", "dom_example2_ex_dom_2_cpp.html", null ],
    [ "DOM/Xpath Example 3 - Advanced Sorting Fetaures of p6IDOMNodeset", "dom_example3.html", null ],
    [ "ex-dom-3.cpp", "dom_example3_ex_dom_3_cpp.html", null ],
    [ "DOM/Xpath Example 4 - Namespaces & XPath 2.0", "dom_example4.html", null ],
    [ "ex-dom-4.cpp", "dom_example4_ex_dom_4_cpp.html", null ],
    [ "namespaces.h", "dom_example4_namespaces_h.html", null ],
    [ "namespaces.cpp", "dom_example4_namespaces_cpp.html", null ],
    [ "DOM/Xpath Example 5 - JsonML with DOM and XPath 2.0", "dom_example5.html", null ],
    [ "ex-dom-5.cpp", "dom_example5_ex_dom_5_cpp.html", null ],
    [ "XSLT 2.0 Implementation", "p6xslt.html", [
      [ "Introduction", "p6xslt.html#p6rxslt_intro", [
        [ "XSLT References", "p6xslt.html#p6rxslt_refs", null ],
        [ "Includes", "p6xslt.html#p6rxslt_includes", null ],
        [ "Interfaces", "p6xslt.html#p6rxslt_interfaces", null ],
        [ "JSON and JsonML Support", "p6xslt.html#p6rxslt_json", null ],
        [ "Performance Considerations", "p6xslt.html#p6rxslt_perf", null ],
        [ "Compiled Templates and Multiple Threads", "p6xslt.html#p6rxslt_compile", [
          [ "\"disabled\" Config Variable (string value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_disabled", null ],
          [ "\"initialSessions\" Config Variable (positive numeric value)", "p6pkcs11.html#p6pkcs11_config_section_pkcs11_gen_initialsessions", null ],
          [ "XSLT Elements and Functions Not Yet Implemented", "p6xslt.html#p6rxslt_notyet", null ],
          [ "Saxon XSLT Element Extensions", "p6xslt.html#saxon_ext", null ]
        ] ]
      ] ],
      [ "Attribute Value Templates", "p6xslt.html#p6rxslt_value", [
        [ "How We Encode QNames", "p6xslt.html#p6rxslt_qnames", null ],
        [ "Other Differences", "p6xslt.html#p6rxslt_diffs", null ]
      ] ]
    ] ],
    [ "XSLT Examples", "xslt_examples.html", [
      [ "XSLT Examples", "xslt_examples.html#xslt_ex_into", null ]
    ] ],
    [ "XSLT Example 1 - The bare minimum", "xslt_example1.html", null ],
    [ "ex-xslt1.cpp", "xslt_example1_ex_xslt1_cpp.html", null ],
    [ "filestream.h", "xslt_example1_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example1_filestream_cpp.html", null ],
    [ "XSLT Example 2 - Using JSON", "xslt_example2.html", null ],
    [ "ex-xslt2.cpp", "xslt_example2_ex_xslt2_cpp.html", null ],
    [ "filestream.h", "xslt_example2_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example2_filestream_cpp.html", null ],
    [ "XSLT Example 3 - Exending Functionality with XPath 2.0", "xslt_example3.html", null ],
    [ "ex-xslt3.cpp", "xslt_example3_ex_xslt3_cpp.html", null ],
    [ "filestream.h", "xslt_example3_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example3_filestream_cpp.html", null ],
    [ "cxpathextend.h", "xslt_example3_cxpathextend_h.html", null ],
    [ "cxpathextend.cpp", "xslt_example3_cxpathextend_cpp.html", null ],
    [ "embeddedxml.xsl", "xslt_example3_embeddedxml_xsl.html", null ],
    [ "XSLT Example 4 - Character Maps", "xslt_example4.html", null ],
    [ "ex-xslt4.cpp", "xslt_example4_ex_xslt4_cpp.html", null ],
    [ "filestream.h", "xslt_example4_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example4_filestream_cpp.html", null ],
    [ "RGX Reference Guide", "p6wregex.html", [
      [ "Introduction", "p6wregex.html#p6regex_intro", [
        [ "References", "p6wregex.html#p6regex_refs", null ],
        [ "Includes", "p6wregex.html#p6regex_includes", null ],
        [ "Interfaces", "p6wregex.html#p6regex_interfaces", null ],
        [ "Perl Regular Expression Support", "p6wregex.html#p6regex_perl", null ],
        [ "Mapping from Perl to RGX's API", "p6wregex.html#p6regex_mapping", null ],
        [ "Egrep Regular Expression Support", "p6wregex.html#p6regex_egrep", null ],
        [ "What is special about our Regex Engine", "p6wregex.html#p6regex_special", null ],
        [ "Usage Tips", "p6wregex.html#p6regex_tips", null ],
        [ "Examples", "p6wregex.html#p6regex_examples", null ]
      ] ]
    ] ],
    [ "Example 1 - Split & Explode", "regex_example1.html", null ],
    [ "Example 2 - Three ways to do replace", "regex_example2.html", null ],
    [ "Example 3 - Narrow Examples Including Split and Explode", "regex_example3.html", [
      [ "Simple examples illustrating counting, capture, split and explode", "regex_example3.html#regex_example3_sec1", null ]
    ] ],
    [ "Example 4 - Wide Examples", "regex_example4.html", null ],
    [ "Example 5 - EGREP Style Regex", "regex_example5.html", null ],
    [ "Example 6 - Look-Ahead and Look-Behind", "regex_example6.html", null ],
    [ "CConsoleStream", "regex_cconsolestream.html", [
      [ "Introduction", "regex_cconsolestream.html#regex_cconsolestream_intro", null ]
    ] ],
    [ "Example 7 - Multiple Matches", "regex_example7.html", [
      [ "Introduction", "regex_example7.html#regex_example7_intro", [
        [ "Demonstrates", "regex_example7.html#regex_example7_demonstrates", null ],
        [ ".cpp ex-regex-7.cpp", "regex_example7.html#regex_example7_ex-regex-7", null ]
      ] ]
    ] ],
    [ "Networking APIs", "net.html", null ],
    [ "Secure Socket Networking", "net-ssl.html", [
      [ "Introduction", "net-ssl.html#net-ssl-introduction", [
        [ "Server Trusted Root Certificates", "net-ssl.html#net-ssl-trusted-root-certs", null ]
      ] ],
      [ "SSL Client Connections", "net-ssl.html#net-ssl-client", null ],
      [ "SSL Server Connections", "net-ssl.html#net-ssl-server", [
        [ "Client Authentication", "net-ssl.html#net-ssl-client-auth", null ]
      ] ]
    ] ],
    [ "Asynchronous UDP I/O Engine", "net_udpeng.html", null ],
    [ "Database connector object", "p6dbc.html", [
      [ "Introduction", "p6dbc.html#p6rdbc_intro", [
        [ "Includes", "p6dbc.html#p6rdbc_includes", null ],
        [ "Interfaces", "p6dbc.html#p6rdbc_interfaces", null ],
        [ "Postgres and standard SQL", "p6dbc.html#p6rdbc_compatibility", null ],
        [ "How to add more databases", "p6dbc.html#p6rdbc_plugin", null ],
        [ "Signning Databases", "p6dbc.html#p6rdbc_sign", null ]
      ] ]
    ] ],
    [ "SKC UEFI Platform Reference Guide", "p6uefi.html", [
      [ "Introduction", "p6uefi.html#p6uefi-overview", [
        [ "UEFI Example Application", "p6uefi.html#skc-uefi-example", null ]
      ] ]
    ] ],
    [ "PKCS 11 Command Line Tool Reference Guide", "p6pkcs11tool.html", [
      [ "Introduction", "p6pkcs11tool.html#p6pkcs11tool_intro", null ],
      [ "PKCS 11 Attributes", "p6pkcs11tool.html#p6pkcs11tool_attributes", null ],
      [ "An Object's Alias", "p6pkcs11tool.html#p6pkcs11tool_alias", [
        [ "Adding and Modifying Slots", "p6pkcs11tool.html#p6pkcs11tool_config_section_slot_update", null ]
      ] ],
      [ "C_GetTokenInfo() on an HPE NSP Token", "p6pkcs11tool.html#p6pkcs11tool_NSP_token_list_info", null ]
    ] ],
    [ "KMIP Command Line Tool Reference Guide", "_h_p_e_p6kmiptool.html", [
      [ "Introduction", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_intro", null ],
      [ "Basic Configuration Parameters", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config", [
        [ "The [COMMAND-TOOL] Config Section*", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config_section_kmip_gen", [
          [ "\"baseKeyPath\" Config Variable (string Value)", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config_section_kmip_gen_baseKeyPath", null ],
          [ "\"locale\" Config Variable (string Value)", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config_section_kmip_gen_locale", null ],
          [ "\"keystore\" Config Variable (string value)", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config_section_kmip_gen_keystore", null ],
          [ "Per KMIP Server Section", "_h_p_e_p6kmiptool.html#HPE_p6kmiptool_config_section_kmip_gen_server", null ]
        ] ]
      ] ]
    ] ],
    [ "KMIP Command Line Tool Reference Guide", "p6kmiptool.html", [
      [ "Introduction", "p6kmiptool.html#p6kmiptool_intro", null ],
      [ "KMIP Attributes and more", "p6kmiptool.html#p6kmiptool_attributes", null ],
      [ "Minimum Requirements to connect to a KMIP Server", "p6kmiptool.html#p6kmiptool_minimum", null ],
      [ "Basic Configuration Parameters", "p6kmiptool.html#p6kmiptool_config", [
        [ "The [COMMAND-TOOL] Config Section*", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen", [
          [ "\"baseKeyPath\" Config Variable (string Value)", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen_baseKeyPath", null ],
          [ "\"customerKeyPath\" Config Variable (string Value)", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen_customerKeyPath", null ],
          [ "\"locale\" Config Variable (string Value)", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen_locale", null ],
          [ "\"keystorePath\" Config Variable (string value)", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen_keystorePath", null ],
          [ "Per KMIP Server Section", "p6kmiptool.html#p6kmiptool_config_section_kmip_gen_server", null ]
        ] ],
        [ "Modifying KMIP Servers", "p6kmiptool.html#p6kmiptool_config_section_kmip_update", null ],
        [ "Limitations and Advanced Features", "p6kmiptool.html#p6kmiptool_limitations", null ]
      ] ]
    ] ],
    [ "The P6R Component Object Model", "base_com.html", [
      [ "Introduction", "base_com.html#base_com_intro", null ],
      [ "P6COM Component Object Rules", "base_com.html#base_com_rules", null ],
      [ "Rules for designing binary compatible interfaces.", "base_com.html#base_com_binif", null ]
    ] ],
    [ "What is [p6]COM", "base_p6rcom_whatis.html", [
      [ "Introduction", "base_p6rcom_whatis.html#base_p6rcom_intro", [
        [ "Resource Management", "base_p6rcom_whatis.html#base_p6rcom_refcount", null ],
        [ "Runtime Polymorphism", "base_p6rcom_whatis.html#base_p6rcom_poly", null ],
        [ "Dynamic Linking", "base_p6rcom_whatis.html#base_p6rcom_dynalink", null ],
        [ "Encapsulation", "base_p6rcom_whatis.html#base_p6rcom_encap", null ]
      ] ]
    ] ],
    [ "P6COM Helpers", "base_p6com_helpers.html", null ],
    [ "P6 Error Codes", "errorcodes.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespace Members", "namespacemembers.html", [
      [ "All", "namespacemembers.html", "namespacemembers_dup" ],
      [ "Functions", "namespacemembers_func.html", null ],
      [ "Variables", "namespacemembers_vars.html", null ],
      [ "Typedefs", "namespacemembers_type.html", null ],
      [ "Enumerations", "namespacemembers_enum.html", null ],
      [ "Enumerator", "namespacemembers_eval.html", "namespacemembers_eval" ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"_h_p_e_p6kmiptool.html",
"functions_func_0x66.html",
"group__type__definitions_ga1ecf639b685cece146140906c2c6888d.html#gga1ecf639b685cece146140906c2c6888da54913c680949b66dfe5dabf528c694b4",
"json_example1_ccontenthandler_cpp.html",
"p6crc16_8h.html",
"p6defs_8h.html#ab37a4426e13e634bd1bef590573c68e3",
"p6fsm_8h_source.html",
"p6kmipdecoder_8h.html#a690bfe3ad1ebaf32827977a0b52cc861",
"p6runtimeapi_8h.html#ga18cbc7f4fd034874c432a922d6b9cbe4",
"p6types_8h.html#ga207b27a44afc979283f907577e90b5f8",
"p6uefidefs_8h.html#a9ef96524f3ea31af8d81b9de45374930",
"pkcs11t_8h.html#a021c552be6c4bb687fa6f27f0d5c6551",
"pkcs11t_8h.html#a468971392c5970e96adc63a9e69ecb23",
"pkcs11t_8h.html#a938d3ebc9bace3a9da81abf33c16a932",
"pkcs11t_8h.html#ad5943f11b67c32a40d4d6687e9cbb64b",
"struct_c_k___c_c_m___p_a_r_a_m_s_a893590a9361df0b99a2d79de1bde1230.html#a893590a9361df0b99a2d79de1bde1230",
"struct_c_k___t_l_s12___k_e_y___m_a_t___p_a_r_a_m_s_ac894353a02b1c63d4de5f1efa1b95f73.html#ac894353a02b1c63d4de5f1efa1b95f73",
"struct_p6_r_1_1_p6_k_e_y_s_t_o_r_e___a_t_t_r_i_b_u_t_e.html",
"struct_p6_r_1_1_p6_k_m_i_p___e_n_c_o_d_e_r___p_r_e_f_a607666bb4c72451efea649e903d205f6.html#a607666bb4c72451efea649e903d205f6",
"struct_p6_r_1_1_p6_k_m_i_p___p_r_e_f_ae0d16fb48451cfe95a9465d7fb4dd8dc.html#ae0d16fb48451cfe95a9465d7fb4dd8dc",
"struct_p6_r_1_1_p6_k_m_i_p___w_r_a_p_p_e_d_k_e_y_aed95114f4c4075bc23957338c4c2490c.html#aed95114f4c4075bc23957338c4c2490c",
"struct_p6_r_1_1p6_i_cert_a21fdc4471c3277501b45b636789dfd66.html#a21fdc4471c3277501b45b636789dfd66",
"struct_p6_r_1_1p6_i_d_h_key_exchange_a2296e487d177fa45e0cd2f7812f8524f.html#a2296e487d177fa45e0cd2f7812f8524f",
"struct_p6_r_1_1p6_i_enum_strtbl_values.html",
"struct_p6_r_1_1p6_i_i18n_file_a536f8b1391759019f4b1826249fea8e8.html#a536f8b1391759019f4b1826249fea8e8",
"struct_p6_r_1_1p6_i_k_m_i_p_client3_af71d1406b161e16145c1be71bb51d896.html#af71d1406b161e16145c1be71bb51d896",
"struct_p6_r_1_1p6_i_k_m_i_p_request_ac7adea5412bd1b266614fe266ad6a4d8.html#ac7adea5412bd1b266614fe266ad6a4d8",
"struct_p6_r_1_1p6_i_keystore4_a999a1ffc5fa8c478c70e5dd0423e4eb8.html#a999a1ffc5fa8c478c70e5dd0423e4eb8",
"struct_p6_r_1_1p6_i_packet_a567140e34cacd9cfcd382a6e2567f3b6.html#a567140e34cacd9cfcd382a6e2567f3b6",
"struct_p6_r_1_1p6_i_safe_string_aa290416d805a5769b1ae9d29d2978d1a.html#aa290416d805a5769b1ae9d29d2978d1a",
"struct_p6_r_1_1p6_i_token_impl2_a80e7fb1222565d855216d50bf6f9adda.html#a80e7fb1222565d855216d50bf6f9adda",
"struct_p6_r_1_1p6_i_w_string_buf_aac8498820b1480140e977ca927ec19b3.html#aac8498820b1480140e977ca927ec19b3"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&nbsp;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

